  
#property copyright "(c) Tradex Capital Markets Latvia Ltd "
#property link      "http://www.tradexgroup.com"
#define MAGICMA  20051108

#include <stdlib.mqh>
#include <WinUser32.mqh>

//---- darijumu parametri-------------------------------------------------------	
   extern double lots=1;                //lots
   extern int TakeProfit=15;              //value of take profit
   extern int StopLoss=150;                //value of stop loss
   extern int Close_signal=1;             //1-true   0-false [close possition at reversal signal]
   extern int AL=1;           // 1-show alerts     0-none

//------------ PD ------- parametri-------------------------------------------
   extern int N1=3;            // how many periods needed to confirm
   extern int N2=2;            // how many brakeouts needed
//-------------------------------------------------------------------------------------------------





int deinit()
  {
  ObjectsDeleteAll(0,OBJ_ARROW);
  ObjectsDeleteAll(0,OBJ_HLINE);
//---- 
  return;
  }
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
Comment("\n","Paatrinajuma Dienu Izsisanas Sistema ");   


   double PDmax[50], PDmin[50], minmin, maxmax, stMAINPrev, stSIGPrev, sl, tp;
   int    res, error, skUp, skDn, UD ;
   bool   UpPD[50], DnPD[50];
      
   for (int k=1; k<=50; k++)
      {   
      UpPD[k]=True;
      DnPD[k]=True;
      PDmax[k]=High[N1+k];
      PDmin[k]=Low[N1+k];
         
      for (int d=1; d<=N1; d++)   
         {
        // mekl? augo?as PD
            if (PDmax[k]>High[N1+k+d] && UpPD[k]==True) 
               {
               if (PDmin[k]<Low[N1+k-d] && UpPD[k]==True)   
                  {
                  UpPD[k]=True;
                  }
                  else
                  UpPD[k]=False;
               }
               else
               UpPD[k]=False;

        // mekl? kr?to?a PD
            if (PDmax[k]>High[N1+k-d] && DnPD[k]==True) 
               {
               if (PDmin[k]<Low[N1+k+d] && DnPD[k]==True)   
                  {
                  DnPD[k]=True;
                  }
                  else
                  DnPD[k]=False;
               }
               else
               DnPD[k]=False;

         }
        if (UD==0 && DnPD[k])
         UD=1;  
        if (UD==0 && UpPD[k])
         UD=2;  
      // uzziimee bultinjas
        if (UpPD[k]==True) 
        {
        ObjectCreate("PD"+k,OBJ_ARROW,0,Time[N1+k],High[N1+k]);
        ObjectSet("PD"+k,OBJPROP_ARROWCODE,SYMBOL_ARROWUP);
        }
        
        if (DnPD[k]==True) 
        {
        ObjectCreate("PD"+k,OBJ_ARROW,0,Time[N1+k],Low[N1+k]);
        ObjectSet("PD"+k,OBJPROP_ARROWCODE,SYMBOL_ARROWDOWN);
        }
        
        // meklee N2 PD min v?rt?bu       
          if (UpPD[k]==True && skUp<N2)
            {
            skUp=skUp+1;
            if (minmin==0 || minmin>Low[N1+k] )   
               minmin=Low[N1+k];
            }   
        // meklee N2 PD max v?rt?bu       
          if (DnPD[k]==True && skDn<N2)
            {
            skDn=skDn+1;
            if (maxmax==0 || maxmax<High[N1+k] )   
               maxmax=High[N1+k];
            }   
         // uzziimee liinijas
        
     }
       if ( UD==2 ) 
        {
        ObjectCreate("LineUp",OBJ_HLINE,0,0,minmin);       
        ObjectSet("LineUp",OBJPROP_COLOR,Red);
        }
       if ( UD==1 ) 
        {
        ObjectCreate("LineDn",OBJ_HLINE,0,0,maxmax);       
        ObjectSet("LineDn",OBJPROP_COLOR,Blue);
        }
         

//     Print(" --------------------------------------" );
  
//----
   return(0);
  }  



//+------------------------------------------------------------------+
// apr??ina cik poz atv?rtas
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- atgrie? atverto poz. skaitu
   if(buys>0) return(buys);
   else       return(-sells);
  }
  
  

//+------------------------------------------------------------------+
//| parbauda poz?cijas atv?r?anas nosac?jumus                        |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double PDmax[20], PDmin[20], minmin, maxmax, stMAINPrev, stSIGPrev, sl, tp;
   int    res, error, skUp, skDn , UD;
   bool   UpPD[20], DnPD[20];
      
   for (int k=1; k<=20; k++)
      {   
      UpPD[k]=True;
      DnPD[k]=True;
      PDmax[k]=High[N1+k];
      PDmin[k]=Low[N1+k];
      
         
      for (int d=1; d<=N1; d++)   
         {
        // mekl? augo?as PD
            if (PDmax[k]>High[N1+k+d] && UpPD[k]==True) 
               {
               if (PDmin[k]<Low[N1+k-d] && UpPD[k]==True)   
                  {
                  UpPD[k]=True;
                  }
                  else
                  UpPD[k]=False;
               }
               else
               UpPD[k]=False;

        // mekl? kr?to?a PD
            if (PDmax[k]>High[N1+k-d] && DnPD[k]==True) 
               {
               if (PDmin[k]<Low[N1+k+d] && DnPD[k]==True)   
                  {
                  DnPD[k]=True;
                  }
                  else
                  DnPD[k]=False;
               }
               else
               DnPD[k]=False;
        // meklee N2 PD min v?rt?bu       
          if (UpPD[k]==True && skUp<N2)
            {
            skUp=skUp+1;
            if (minmin==0 || minmin>Low[N1+k] )   
               minmin=Low[N1+k];
            }   
        // meklee N2 PD max v?rt?bu       
          if (DnPD[k]==True && skDn<N2)
            {
            skDn=skDn+1;
            if (maxmax==0 || maxmax<High[N1+k] )   
               maxmax=High[N1+k];
            }   
         // nosaka virzienu   
        if (UD==0 && DnPD[k])
         UD=1;  
        if (UD==0 && UpPD[k])
         UD=2;             
            
         }
       // Print( TimeToStr(Time[N1+k],TIME_DATE)," AugPD:",UpPD[k]," KritPD:",DnPD[k], " k:",k); 
        
     
     }
    // Print(" --------------------------------------" );

   
  
//ja ir SELL sign?ls 
      if ( UD==1  &&  // 
           maxmax<=Bid ) {                          // PD SELL signals
           if (StopLoss==0) {sl=0;} else sl=Bid+Point*StopLoss;
           if (TakeProfit==0) {tp=0;} else tp=Bid-Point*TakeProfit;
           res = OrderSend(Symbol(),OP_SELL,lots,Bid,3,sl,tp,NULL,MAGICMA,0,Blue); // def
           if(res<0){
               error=GetLastError();
               Print("Error = ",ErrorDescription(error));
               }
           else
           {
             if (AL==1) Alert(Symbol(), Period(), " Sell ",Bid);
           }    
               
           }     
 
//ja ir BUY sign?ls
      if ( UD==2 &&   // ST krustpunkts
            minmin >= Ask ) {                       // PD BUY signals
            if (StopLoss==0) {sl=0;} else sl=Ask-Point*StopLoss;
            if (TakeProfit==0) {tp=0;} else tp=Ask+Point*TakeProfit;
            res = OrderSend(Symbol(),OP_BUY,lots,Ask,3,sl,tp,NULL,MAGICMA,0,Red); // def
            if(res<0){
               error=GetLastError();
               Print("Error = ",ErrorDescription(error));
               }
            else
            {
            if (AL==1) Alert(Symbol(), Period(), " Buy ",Ask);        
            }
            
          }   
//----
   return;
  }
  
//+------------------------------------------------------------------+
//| parbauda poz?cijas sl?g?anas nosac?jumus                         |
//+------------------------------------------------------------------+
void CheckForClose()
  {
 
   double PDmax[9], PDmin[9], minmin, maxmax, stMAINPrev, stSIGPrev, sl, tp;
   int    res, error, skUp, skDn , UD;
   bool   UpPD[9], DnPD[9];
   
   if (Close_signal==0) return;
//--------------------------------------------
   for (int k=1; k<=20; k++)
      {   
      UpPD[k]=True;
      DnPD[k]=True;
      PDmax[k]=High[N1+k];
      PDmin[k]=Low[N1+k];
      
         
      for (int d=1; d<=N1; d++)   
         {
        // mekl? augo?as PD
            if (PDmax[k]>High[N1+k+d] && UpPD[k]==True) 
               {
               if (PDmin[k]<Low[N1+k-d] && UpPD[k]==True)   
                  {
                  UpPD[k]=True;
                  }
                  else
                  UpPD[k]=False;
               }
               else
               UpPD[k]=False;

        // mekl? kr?to?a PD
            if (PDmax[k]>High[N1+k-d] && DnPD[k]==True) 
               {
               if (PDmin[k]<Low[N1+k+d] && DnPD[k]==True)   
                  {
                  DnPD[k]=True;
                  }
                  else
                  DnPD[k]=False;
               }
               else
               DnPD[k]=False;
        // meklee N2 PD min v?rt?bu       
          if (UpPD[k]==True && skUp<N2)
            {
            skUp=skUp+1;
            if (minmin==0 || minmin>Low[N1+k] )   
               minmin=Low[N1+k];
            }   
        // meklee N2 PD max v?rt?bu       
          if (DnPD[k]==True && skDn<N2)
            {
            skDn=skDn+1;
            if (maxmax==0 || maxmax<High[N1+k] )   
               maxmax=High[N1+k];
            }   
         // nosaka virzienu   
        if (UD==0 && DnPD[k])
         UD=1;  
        if (UD==0 && UpPD[k])
         UD=2;             
            
         }
       // Print( TimeToStr(Time[N1+k],TIME_DATE)," AugPD:",UpPD[k]," KritPD:",DnPD[k], " k:",k); 
        
     
     }
    // Print(" --------------------------------------" );

//--------------------------------------------   
  

   for(int i=0;i<OrdersTotal();i++)
   {    if (OrderType()==OP_BUY )
       {
//ja ir SELL sign?ls 
      if ( UD==1  &&  // 
           maxmax<=Bid ) {                          // MA SELL signals
           res = OrderClose(OrderTicket(),OrderLots(),Bid,3,White); // close 
           if(res<0){
               error=GetLastError();
               Print("Error = ",ErrorDescription(error));
               }
            else
            {
            if (AL==1) Alert("CLOSE ", Symbol(), Period(), " Buy ",Bid);        
            }
               
            }     
       } // end OP_BUY check
//---- 
       if (OrderType()==OP_SELL) 
       {
//ja ir BUY sign?ls 
      if ( UD==2 &&   // ST krustpunkts
            minmin >= Ask  ) {                          // MA BUY signals
           res = OrderClose(OrderTicket(),OrderLots(),Ask,3,White); // close 
           if(res<0){
               error=GetLastError();
               Print("Error = ",ErrorDescription(error));
               }
            else
            {
            if (AL==1) Alert("CLOSE ", Symbol(), Period(), " Sell ",Ask);        
            }

            }     
       }  // end OP_SELL check

// ------
  } // end For
     
     
// -----     
     return;
        
//----
  }


int start()
  {

//---- ja nav no k? r??jinat MA, tad beigas
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- ja poz. atv?rtas tad ...
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else                                    CheckForClose();
   
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
// developed by Joke
//+------------------------------------------------------------------+


